package com.realnet.vpspack.Services;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;

import com.realnet.realm.Entity.Realm;
import com.realnet.realm.Services.RealmService;
import com.realnet.users.entity1.AppUser;
import com.realnet.users.service1.AppUserServiceImpl;
import com.realnet.vpspack.Entity.Visa_duration;
import com.realnet.vpspack.Entity.Visa_entry;
import com.realnet.vpspack.Entity.Visa_prices;
import com.realnet.vpspack.Entity.Visa_processing;
import com.realnet.vpspack.Repository.Visa_pricesRepository;

@Service
public class Visa_pricesService {
	@Autowired
	private Visa_pricesRepository Repository;
	@Autowired
	private AppUserServiceImpl userService;
	@Autowired
	private RealmService realmService;

	@Autowired
	private Visa_entryService visa_entry_typeserv;

	@Autowired
	private Visa_durationService visa_durationserv;

	@Autowired
	private Visa_processingService visa_processingserv;

	public Visa_prices Savedata(Visa_prices data) {

		if (data.getVisa_entry_type() != null) {
			Visa_entry get = visa_entry_typeserv.getdetailsbyId(data.getVisa_entry_type());
			data.setVisa_entry_typename(get.getName());

		}

		if (data.getVisa_duration() != null) {
			Visa_duration get = visa_durationserv.getdetailsbyId(data.getVisa_duration());
			data.setVisa_durationname(get.getName());

		}

		if (data.getVisa_processing() != null) {
			Visa_processing get = visa_processingserv.getdetailsbyId(data.getVisa_processing());
			data.setVisa_processingname(get.getName());

		}

		data.setUpdatedBy(getUser().getUserId());
		data.setCreatedBy(getUser().getUserId());
		data.setAccountId(getUser().getAccount().getAccount_id());
		Visa_prices save = Repository.save(data);
		return save;
	}

//	get all with pagination
	public Page<Visa_prices> getAllWithPagination(Pageable page) {
		return Repository.findAll(page, getUser().getUserId());
	}

	public List<Visa_prices> getdetails() {
		List<Realm> realm = realmService.findByUserId(getUser().getUserId());
		List<Visa_prices> all = Repository.findAll(getUser().getUserId());

		return all;
	}

	public Visa_prices getdetailsbyId(Integer id) {
		return Repository.findById(id).get();
	}

	public void delete_by_id(Integer id) {
		Repository.deleteById(id);
	}

	public Visa_prices update(Visa_prices data, Integer id) {
		Visa_prices old = Repository.findById(id).get();
		old.setName(data.getName());

		old.setDescription(data.getDescription());

		old.setActive(data.isActive());

		old.setVisa_entry_type(data.getVisa_entry_type());

		old.setVisa_duration(data.getVisa_duration());

		old.setVisa_processing(data.getVisa_processing());

		old.setTotal_price(data.getTotal_price());

		old.setCost(data.getCost());

		final Visa_prices test = Repository.save(old);
		data.setUpdatedBy(getUser().getUserId());
		return test;
	}

	public AppUser getUser() {
		AppUser user = userService.getLoggedInUser();
		return user;

	}
}
